<template>  
  <el-card style="flex: 1;margin-left: 10px;margin-top: 10px;margin-right: 10px;" v-loading="loading">
    <el-scrollbar height="600px">
<div id="top" style="height: 150px;display: flex;">  
  <div class="echarts-container">
  <div v-for="(processData, index) in processesData" :key="index" class="echarts-item">
    <div :id="'pieChart_' + index" class="pie-chart"></div>
  </div>
</div>
</div> 
<div style="display: flex;">
<div id="centerleft" style="margin-top: 10px;height: 240px;width: 340px;background-color: #911005;">
  <el-table height="240" ref="table" width="340px"
      @selection-change="handleSelectionChange"
      :data="tableData" :header-cell-style="{background:'#F2F3F5 ',color:'#1D2129'}">
        <el-table-column fixed prop="orderId" align="center" :label="$t('large.number')" min-width="110" />
        <el-table-column prop="project" align="center" :label="$t('large.projectname')" min-width="100" />
        <el-table-column prop="responsibleProcess" align="center" :label="$t('large.responsibleprocess')" min-width="100" />
        <el-table-column prop="breakageQuantity" align="center" :label="$t('large.numberfractions')" min-width="110" />
        <el-table-column prop="patchProcesses" align="center" :label="$t('large.process')" min-width="100" />
        <el-table-column fixed="right" :label="$t('large.operate')" align="center" width="100">
          <template #default="scope">
            <el-button size="mini" type="text" plain @click="handleBinda">{{ $t('large.mes') }}</el-button>
          </template>
      </el-table-column>
      </el-table>
</div> 
<div id="center" style="margin-top: 10px;margin-left: 10px; height: 240px;width: 750px;">
  <img src="../../assets/d1a.png" alt="" style="margin-left: -10px; width: 100%;height: 100%;position: relative;"> 
</div>
<div id="centerright" style="margin-top: 10px;margin-left: 10px; height: 240px;width: 240px;background-color: #911005;">
  <el-table height="240" ref="table" width="340px"
      @selection-change="handleSelectionChange"
      :data="tableDatab" :header-cell-style="{background:'#F2F3F5 ',color:'#1D2129'}">
        <el-table-column prop="projectNo" align="center" :label="$t('large.projectnumber')" min-width="50" />
        <el-table-column prop="projectName" align="center" :label="$t('large.projectname')" min-width="50" />
      </el-table>
</div> 
</div>
<div id="bottom" style="margin-top: 10px;height: 190px;background-color: #911005;">
<el-table height="190" ref="table"
      @selection-change="handleSelectionChange"
      :data="tableDatac" :header-cell-style="{background:'#F2F3F5 ',color:'#1D2129'}">
        <el-table-column prop="orderId" align="center" :label="$t('large.orderId')" min-width="50" />
        <el-table-column prop="customerName" align="center" :show-overflow-tooltip="true" :label="$t('large.customerName')" min-width="90" />
        <el-table-column prop="project" align="center" :label="$t('large.project')" min-width="50" />
        <el-table-column prop="area" align="center" :label="$t('large.are')" min-width="50" />
        <el-table-column prop="quantity" align="center" :label="$t('large.quantity')" min-width="50" />
        <el-table-column
          align="center"
          :label="$t('large.warehousing')"
          min-width="50"
          prop="warehousing"
        >
        <template #default="scope">  
      <el-tag :type="getStatusType(scope.row.warehousing)">  
        {{ getStatusText(scope.row.warehousing) }}  
      </el-tag>  
    </template> 
        </el-table-column>
        <el-table-column prop="deliveryDate" align="center" :label="$t('large.deliveryDate')" min-width="50" />
      </el-table>
</div>
</el-scrollbar>
</el-card>
<el-dialog v-model="blinda" top="5vh" width="80%" :title="$t('large.brokeno')">
  <el-table height="400" ref="table" 
      @selection-change="handleSelectionChange"
      :data="tableData" :header-cell-style="{background:'#F2F3F5 ',color:'#1D2129'}">
        <el-table-column prop="reportingWorkTime" fixed align="center" :label="$t('large.time')" min-width="110" />
        <el-table-column prop="orderId" fixed align="center" :label="$t('large.number')" min-width="110" />
        <el-table-column prop="reportingWorkId" align="center" :label="$t('large.jobnumber')" min-width="120" />
        <el-table-column prop="productionId" align="center" :label="$t('large.productionnumber')" min-width="130" />
        <el-table-column prop="processId" align="center" :label="$t('large.cardnumber')" min-width="140" />
        <el-table-column prop="project" align="center" :label="$t('large.projectname')" min-width="110" />
        <el-table-column prop="batch" align="center" :label="$t('large.batch')" min-width="110" />
        <el-table-column prop="reviewer" align="center" :label="$t('large.detailID')" min-width="110" />
        <el-table-column prop="orderSort" align="center" :label="$t('large.serialnumber')" min-width="110" />
        <el-table-column prop="productName" align="center" :label="$t('large.productname')" :show-overflow-tooltip="true" min-width="220" />
        <el-table-column prop="technologyNumber" align="center" :label="$t('large.serial')" min-width="110" />
        <el-table-column prop="glassAddress" align="center" :label="$t('large.slicemarker')" min-width="130" />
        <el-table-column prop="patchNum" align="center" :label="$t('large.numberpatches')" min-width="110" />
        <el-table-column prop="width" align="center" :label="$t('large.width')" min-width="110" />
        <el-table-column prop="height" align="center" :label="$t('large.height')" min-width="110" />
        <el-table-column prop="shape" align="center" :label="$t('large.shape')" min-width="110" />
        <el-table-column prop="responsibleProcess" align="center" :label="$t('large.responsibleprocess')" min-width="110" />
        <el-table-column prop="patchProcesses" align="center" :label="$t('large.process')" min-width="110" />
        <el-table-column prop="breakageQuantity" align="center" :label="$t('large.numberfractions')" min-width="110" />
        <el-table-column prop="patchReason" align="center" :label="$t('large.breakreason')" min-width="110" />
        <el-table-column prop="patchType" align="center" :label="$t('large.breaktype')" min-width="110" />
        <el-table-column prop="responsiblePersonnel" align="center" :label="$t('large.responsiblepersonnel')" min-width="110" />
        <el-table-column prop="responsibleEquipment" align="center" :label="$t('large.responsiblequipment')" min-width="110" />
        <el-table-column prop="responsibleTeam" align="center" :label="$t('large.responsibleteam')" min-width="110" />
        <el-table-column prop="patchArea" align="center" :label="$t('large.area')" min-width="110" />
        <el-table-column prop="qualityInspector" align="center" :label="$t('large.inspector')" min-width="110" />
      </el-table>
  <template #footer>
    <div id="dialog-footer" style="text-align: center;">
      <el-button @click="blinda = false">{{ $t('large.close') }}</el-button>
    </div>
  </template>
</el-dialog>
</template>  
<script setup>  
import { Delete, Upload } from '@element-plus/icons-vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { ref, onMounted , onBeforeUnmount, reactive, computed, shallowRef, onUnmounted, watchEffect } from "vue";
import request from "@/utils/request"
import { WebSocketHost ,host} from '@/utils/constants'
import { initializeWebSocket, closeWebSocket } from '@/utils/WebSocketService';
import { useI18n } from 'vue-i18n'
const { t } = useI18n()
import * as echarts from 'echarts';
const tableData = ref([])
const tableDatab = ref([])
const tableDatac = ref([])
const adjustedRects = ref([]);  
const chartRefs = ref([]);  
const thisProcess = ref(); // 用于存储process_id的响应式引用 
// 定义一个响应式引用来存储图表实例    
const chartDom = ref(null);  
let chartInstance = null;  
const blinda = ref(false)
const handleBinda = (row) => {
blinda.value = true;
};
const processesData = ref([

]);
function getStatusType(warehousing) {  
switch (warehousing) {  
  case 0:  
    return 'info';  
  case 1:  
    return 'warning';  
  case 2:  
    return 'success';  
}  
}  
function getStatusText(warehousing) {  
switch (warehousing) {
  case 0:  
    return t('large.notstocked');
  case 1:  
    return t('large.inboundstatus');
  case 2:  
  return t('large.allstatus');
}  
}  
let socket = null;
const socketUrl = `ws://${WebSocketHost}:${host}/api/temperingGlass/api/talk/screen`;
const handleMessage = (data) => {
tableData.value = data.awaitingRepairs[0]
tableDatab.value = data.DoingTask[0]
tableDatac.value = data.orders[0]
// adjustedRects.value = data.device[0].map(rect => ({  
//       ...rect, 
//       completed: rect.completedQuantity,
//       breakage: rect.breakageQuantity,
//       thisProcess: rect.thisProcess,
//     })); 
};
// let socket;
// 设置图表 DOM 引用  
function setChartDom(index, el) {  
if (!chartRefs.value[index]) {  
  chartRefs.value[index] = { dom: el, chart: null };  
} else {  
  chartRefs.value[index].dom = el;  
}  
} 
onMounted(() => {  
socket = new WebSocket(socketUrl);  
socket.onmessage = (event) => {  
  const data = JSON.parse(event.data);  
  processesData.value = data.device[0].map(rect => ({  
    ...rect,  
    completedQuantity: rect.completedQuantity,  
    breakageQuantity: rect.breakageQuantity,  
    thisProcess: rect.thisProcess,  
  }));  
  renderPieCharts();
  console.log(processesData.value);
  // updateCharts();
};
  
// };  
});  
const renderPieCharts = () => {
processesData.value.forEach((data, index) => {
  const chart = echarts.init(document.getElementById('pieChart_' + index));
  const options = {
    title: {
        text: `${data.thisProcess} `,
        left: 'center',
      },
    tooltip: {
      trigger: 'item',
    },
    series: [
      {
        name: `${data.thisProcess} `,
        type: 'pie',
        radius: ['40%', '70%'],
        avoidLabelOverlap: false,
        data: [
          { value: data.completedQuantity, name: t('large.completedquantity') },
          { value: data.breakageQuantity, name: t('large.scrapquantity') }
        ],
        emphasis: {
          itemStyle: {
            shadowBlur: 10,
            shadowOffsetX: 0,
            shadowColor: 'rgba(0, 0, 0, 0.5)'
          }
        },
        label: {
          show: false,
          position: 'center',
        },
      labelLine: {
        show: false
      },
      }
    ]
  };

  chart.setOption(options);
});
};


onUnmounted(() => {  
socket.close();  
});  
onMounted(() => {
  socket = initializeWebSocket(socketUrl, handleMessage);
});
  onUnmounted(() => {
    if (socket) {
    closeWebSocket(socket);
    }
    });
onBeforeUnmount(() => {
console.log("关闭了")
closeWebSocket();
});
</script>  

<style scoped>  



.echarts-container {
display: flex;
flex-wrap: wrap;
gap: 20px;
}

.echarts-item {
width: 150px;
height: 150px;
margin: 20px;
}

.pie-chart {
width: 100%;
height: 100%;
}
</style>